/*****************************************************************************/
/*                                                                           */
/*				    macro.h				     */
/*                                                                           */
/*		      Macros for the ca65 macroassembler		     */
/*                                                                           */
/*                                                                           */
/*                                                                           */
/* (C) 1998-2000 Ullrich von Bassewitz                                       */
/*               Wacholderweg 14                                             */
/*               D-70597 Stuttgart                                           */
/* EMail:        uz@musoftware.de                                            */
/*                                                                           */
/*                                                                           */
/* This software is provided 'as-is', without any expressed or implied       */
/* warranty.  In no event will the authors be held liable for any damages    */
/* arising from the use of this software.                                    */
/*                                                                           */
/* Permission is granted to anyone to use this software for any purpose,     */
/* including commercial applications, and to alter it and redistribute it    */
/* freely, subject to the following restrictions:                            */
/*                                                                           */
/* 1. The origin of this software must not be misrepresented; you must not   */
/*    claim that you wrote the original software. If you use this software   */
/*    in a product, an acknowledgment in the product documentation would be  */
/*    appreciated but is not required.                                       */
/* 2. Altered source versions must be plainly marked as such, and must not   */
/*    be misrepresented as being the original software.                      */
/* 3. This notice may not be removed or altered from any source              */
/*    distribution.                                                          */
/*                                                                           */
/*****************************************************************************/



#ifndef MACRO_H
#define MACRO_H



/*****************************************************************************/
/*				     Data				     */
/*****************************************************************************/



/* Macro styles */
#define MAC_STYLE_CLASSIC	0
#define MAC_STYLE_DEFINE	1



/*****************************************************************************/
/*     	       	    		     Code				     */
/*****************************************************************************/



void MacDef (unsigned Style);
/* Parse a macro definition */

void MacExpandStart (void);
/* Start expanding the macro in SVal */

void MacAbort (void);
/* Abort the current macro expansion */

int IsMacro (const char* Name);
/* Return true if the given name is the name of a macro */

int IsDefine (const char* Name);
/* Return true if the given name is the name of a define style macro */

int InMacExpansion (void);
/* Return true if we're currently expanding a macro */



/* End of macro.h */

#endif



